function Screen
% written by Lindo Ouseph
% Research scholar, Department of Electronics,CUSAT,Kochi,India
%capture specific regions from screen and save as video.
%run screen
%enter recording time in seconds
%resize and locate figure window to locate desired location from screen to make video
%close the figure window. done.
%the program starts recording the region screen-shots and write to a video
%file format.
%encoding takes time. so patience!
% Special thankd to  Yair Altman for his excellent script for figure
% transparancy
close all;clc;warning off;
global H Time S filename
prompt = {'Hour';'Minute';'Seconds'};
dlg_title = 'Time';num_lines = 1;def = {'0';'0';'5'};
Time=inputdlg(prompt,dlg_title,num_lines,def);
Time=str2num(Time{1})*3600+str2num(Time{2})*60+str2num(Time{3});
filename=datestr(now,'mm_ss');S=get(0,'screensize');S=S(3:4);
r=get(0,'screensize');
H=figure('position',[r(3)/2-200 r(4)/2-200 400 400],...
    'menubar','none',...
    'numbertitle','off',...
    'resizefcn',@RS,...
    'deletefcn',@Del);
setFigTransparency(H,0.7);
P=get(H,'position');
uicontrol('style','text',...
    'position',[P(3)/2-150,P(4)/2-30,300,60],...
    'string','Resize, Position and Close this window on top of ROI',...
    'foregroundcolor',[1 0 0],...
    'fontsize',15)
%--------------------------------------------------------------------------
function RS(varargin)
global xy H S x1 y2 w h
xy=get(H,'position');
x1=xy(1);
y2=S(2)-(xy(2)+xy(4));
w=xy(3);
h=xy(4);
%--------------------------------------------------------------------------
function Del(varargin)
global h x1 y2 w h Frames S filename
fps=GetFrames(Frames,x1,y2,w,h);
cd ..
Write2File(filename,Frames,fps);
clear all;clc
%--------------------------------------------------------------------------
function fps=GetFrames(Frames,x0,y0,w,h)
global Frames Time
try
    rmdir('snapshots','s');
    pause(3);
end
mkdir snapshots
cd snapshots\
r = java.awt.Robot;
Frames=1;
tic
image = r.createScreenCapture(java.awt.Rectangle(x0,y0,w,h));
javax.imageio.ImageIO.write(image,'jpg',java.io.File([num2str(Frames),'.jpg']));
T=toc;
while T<=Time
    tic
    Frames=Frames+1;
    image = r.createScreenCapture(java.awt.Rectangle(x0,y0,w,h));
    javax.imageio.ImageIO.write(image,'jpg',java.io.File([num2str(Frames),'.jpg']));
    T=T+toc;
end
fps=Frames/T;
%--------------------------------------------------------------------------
function Write2File(filename,Frames,fps)
aviobj = avifile([filename,'.avi'],'compression','Cinepak','fps',fps,'quality',100);
v.colormap=[];
for k=1:Frames
    clc
    disp([num2str(floor(k*100/Frames)),'% frames are encoded'])
    v.cdata=imread(['snapshots\',num2str(k),'.jpg']);
    aviobj = addframe(aviobj,v);
end
aviobj = close(aviobj);
winopen([filename,'.avi']);
clc
disp('Encoding complete')
rmdir('snapshots','s');
fps
%--------------------------------------------------------------------------