function Screen
% written by Lindo Ouseph
%Research scholar, Department of Electronics,CUSAT,Kochi,India
%
%This program captures specific regions from screen and save as video.
%
%Run Screen.m
%enter recording time in seconds
%resize and locate figure window to locate desired location from screen to make video
%close the figure window. done.
%the program starts recording the region screen-shots and write to a video file format.
%encoding takes time. so patience!
%Thnaks for Micah Richert for excellent mmwrite
%Thanks to  Yair Altman for setFigTransparency.m
%http://www.mathworks.in/matlabcentral/fileexchange/downloads/305012/download

close all;clear all;clc;warning off;format short;
try;rmdir('snapshots','s');end
addpath mmwrite
try
    if ~exist('mmwrite')
        urlwrite('http://www.mathworks.in/matlabcentral/fileexchange/downloads/186776/akamai/mmwrite.zip','mmwrite.zip');
        unzip('mmwrite.zip','mmwrite')
    end
catch
    disp({'download http://www.mathworks.in/matlabcentral/fileexchange/15881-mmwrite';'add mmwrite directory to the search path by addpath command'});
    return
end
addpath mmwrite
Time=inputdlg({'Hour';'Minute';'Seconds'},'Time',1,{'0';'0';'5'});drawnow
Time=str2num(Time{1})*3600+str2num(Time{2})*60+str2num(Time{3});
h.s=get(0,'screensize');h.s=h.s(3:4);
[file path]=uiputfile('*.avi');
path=[path,file];
Compress = questdlg('Compress the video?','Compress','Yes','No',[]);
h.f=figure('position',[h.s(1)/2-200 h.s(2)/2-200 400 400],...
    'menubar','none',...
    'numbertitle','off');
set(h.f,'deletefcn',{@Del,h,Time,path,Compress});
setFigTransparency(h.f,0.7);
Top(h.f)
P=get(h.f,'position');
uicontrol('style','text',...
    'position',[P(3)/2-150,P(4)/2-30,300,60],...
    'string','Resize, Position and Close this window on top of ROI',...
    'foregroundcolor',[1 0 0],...
    'fontsize',15)
%--------------------------------------------------------------------------
function Top(hFig)
drawnow expose
fJFrame = get(hFig,'JavaFrame');
fJFrame.fFigureClient.getWindow.setAlwaysOnTop(true);
%--------------------------------------------------------------------------
function Del(~,~,h,Time,path,Compress)
BlockSize=800;
xy=get(h.f,'position');
x1=xy(1);W=xy(3);H=xy(4);y2=h.s(2)-(xy(2)+xy(4));
[T,fps,Frames]=GetFrames(Time,x1,y2,W,H);
cd ..
tic
Write2File(Frames,fps,BlockSize,path,Compress);
toc
disp({['Time : ',num2str(T)];['Frames : ',num2str(Frames)];['FPS : ',num2str(fps)];['Compression : ',Compress]});
clear all;format long;
%--------------------------------------------------------------------------
function [T,fps,Frames]=GetFrames(Time,x0,y0,w,h)
mkdir snapshots
cd snapshots\
r = java.awt.Robot;
Frames=0;T=0;
try
    while T<Time
        tic
        Frames=Frames+1;
        clc;disp([T,Time])
        image = r.createScreenCapture(java.awt.Rectangle(x0,y0,w,h));
        javax.imageio.ImageIO.write(image,'jpg',java.io.File([num2str(Frames),'.jpg']));
        T=T+toc;
    end
catch
    rmdir('snapshots','s');
end
fps=Frames/T;
%--------------------------------------------------------------------------
function Write2File(Frames,fps,BlockSize,path,Compress)
% a=mmwrite('','ListAviVideoEncoders');
conf.videoCompressor='Microsoft Video 1';
v.frames(1).cdata=imread(['snapshots\',num2str(1),'.jpg']);
width=size(v.frames(1).cdata,2);
height=size(v.frames(1).cdata,1);
v.width=width;v.height=height;
Block=800;
try
    for k=1:Block
        v.frames(k).cdata=imread(['snapshots\',num2str(k),'.jpg']);
        v.times(k)=k/fps;
        clc;disp([k,Frames])
    end
    if strcmpi(Compress,'Yes')
        mmwrite(path,v,conf,'Continue');
    else
        mmwrite(path,v,'Continue');
    end
catch
    for i=1:20
        v.frames(end)=[];
        v.times(end)=[];
        clc;disp([k-i,Frames])
    end
    if strcmpi(Compress,'Yes')
        mmwrite(path,v,conf,'Continue');
    else
        mmwrite(path,v,'Continue');
    end
    Block=length(v.frames);
end
i=Block+1;
while 1
    try
        v=[];v.width=width;v.height=height;
        for k=1:Block
            v.frames(k).cdata=imread(['snapshots\',num2str(i),'.jpg']);
            v.times(k)=i/fps;i=i+1;clc;disp([i-1,Frames])
        end
        if strcmpi(Compress,'Yes')
            mmwrite(path,v,conf,'Continue','Initialized');
        else
            mmwrite(path,v,'Continue','Initialized');
        end
    catch
        if strcmpi(Compress,'Yes')
            mmwrite(path,v,conf,'Initialized');
        else
            mmwrite(path,v,'Initialized');
        end
        break
    end
end
winopen(path);
try;rmdir('snapshots','s');end
%--------------------------------------------------------------------------